import { IServiceProvider } from "./IServiceProvider.js";
import { ServiceCollection } from "./ServiceCollection.js";
import type { IAsyncServiceScope, IServiceDescriptor, IServiceScope, IResolverServiceType, SingleServiceType } from "../types/index.js";
export declare class ServiceProvider implements IServiceProvider {
    private readonly collection;
    private readonly parent?;
    static internalGetService<T>(provider: IServiceProvider, service: IResolverServiceType<any, T>, requestedBy: Set<IServiceDescriptor<any>>, mode: "sync" | "async"): Generator<Promise<unknown>, T, unknown>;
    static getDescriptor<T>(provider: IServiceProvider, service: SingleServiceType<T>): IServiceDescriptor<T>;
    static getDescriptors<T>(provider: IServiceProvider, service: SingleServiceType<T>): IServiceDescriptor<T>[];
    private readonly instancesStore;
    constructor(collection: ServiceCollection, parent?: IServiceProvider | undefined);
    getServices<T>(service: SingleServiceType<T>): T[];
    getServiceAsync<T>(service: SingleServiceType<T>): Promise<T>;
    getService<T>(service: SingleServiceType<T>): T;
    getServicesAsync<T>(service: SingleServiceType<T>): Promise<T[]>;
    createScope(): IServiceScope;
    createAsyncScope(): IAsyncServiceScope;
    private internalGetService;
    private resolveServiceImplementation;
    private createInstanceFromDescriptor;
    [Symbol.dispose](): void;
    [Symbol.asyncDispose](): Promise<void>;
}
//# sourceMappingURL=ServiceProvider.d.ts.map