import { resolveGeneratorAsync } from "../helpers/resolveGeneratorAsync.js";
import { resolveGeneratorSync } from "../helpers/resolveGeneratorSync.js";
import { BaseServiceTypeResolver, isServiceTypeResolver, } from "./BaseServiceTypeResolver.js";
export class OptionalServiceTypeResolver extends BaseServiceTypeResolver {
    constructor(next) {
        super(next);
    }
    *resolve(collection, resolveServiceImplementation, requestedBy, mode, descriptor) {
        let next = this.next;
        function* resolve(mode) {
            if (isServiceTypeResolver(next)) {
                return yield* next.resolve(collection, resolveServiceImplementation, requestedBy, mode, descriptor);
            }
            return yield* resolveServiceImplementation(descriptor ?? collection.getDescriptor(next), requestedBy, mode);
        }
        return {
            resolve() {
                return resolveGeneratorSync(resolve("sync"));
            },
            resolveAsync() {
                return resolveGeneratorAsync(resolve("async"));
            },
        };
    }
}
export function isOptionalServiceTypeResolver(value) {
    return value instanceof OptionalServiceTypeResolver;
}
//# sourceMappingURL=OptionalServiceTypeResolver.js.map